package org.realobject;

import java.awt.geom.*;

public abstract class EcoBe {
	private Mark mark_;
	private int id_;
	private double width = 20;
	private double height = 20;

	public EcoBe(int id) {
		id_ = id;
	}
	
	public Mark getMark() {
		return mark_;
	}
	public void putMark(Mark mark) throws Exception {
System.out.println(toString()+".putMark("+mark+")");
		if(mark_ != null) throw new Exception("Mark already exists. "+toString());
		mark_ = mark;
		mark_.setEcobe(this);
	}
	public void removeMark() {
		mark_ = null;
		mark_.setEcobe(null);
	}
	public int getID() {
		return id_;
	}
	public abstract void move(double dx, double dy) ;
	public String getNickName() {
		return toString();//<?>
	}
	public abstract double getRadius() ;
	public abstract double getAngle() ;
	public abstract Point2D.Double getLocation() ;
	public String toString() {
		return "EcoBe[id:"+id_+","+mark_+"]";
	}
}
