package org.realobject;

import java.awt.geom.*;
import org.util.*;

public class Ball {

	private Point2D.Double location_;
	private Point2D.Double velocity_;
	private Point2D.Double force_;
	private double radius_;
	private double mass_;
	
	public Ball(Point2D.Double location, double radius, double mass) {
		location_ = location;
		radius_ = radius;
		mass_ = mass;
		velocity_ = new Point2D.Double(0, 0);
		force_ = new Point2D.Double(0, 0);
	}
	public void setLocation(Point2D.Double location) {
		location_ = location;
	}
	public void move(double dx, double dy) {
		location_.setLocation(location_.getX()+dx, location_.getY()+dy);
	}

	public void setVelocity(double x, double y) {
		velocity_.setLocation(x, y);
	}
	public void setVelocity(Point2D.Double velocity) {
		velocity_ = velocity;
	}
	public Point2D.Double getVelocity() {
		return velocity_;
	}
	
	public void setForce(Point2D.Double force) {
		force_ = force;
	}
	public Point2D.Double getForce() {
		return force_;
	}
	public void setForce(double x, double y) {
		force_.setLocation(x, y);
	}
	public void addForce(double dx, double dy) {
		force_.setLocation(force_.getX()+dx, force_.getY()+dy);
	}
	public Point2D.Double getLocation() {
		return location_;
	}
	public double getMass() {
		return mass_;
	}
	public double getRadius() {
		return radius_;
	}
	public String toString() {
		return "Ball";
	}
}
