package org.realobject;

import java.awt.geom.*;

public class VirtualEcoBe extends EcoBe{
	private double width = 20;
	private double height = 20;
	private double radius_ = 15;
	private double angle_ = 0;
	private Point2D.Double location_;
	
	public	 VirtualEcoBe(int id) {
		super(id);
		location_ = new Point2D.Double(Math.random()*500,Math.random()*500);
	}
	
	public void move(double dx, double dy) {
		location_.setLocation(location_.getX()+dx, location_.getY()+dy);
	}
	public void rotate(double angle) {
		angle_ += angle;
	}

	public double getRadius() {
		return radius_;
	}
	public double getAngle() {
		return angle_;
	}
	public Point2D.Double getLocation() {
		return location_;
	}
}
